#include<bits/stdc++.h>
using namespace std;
int n,q,l,r,br;
long long res;
string ss;
void set1(){
    cout<<r-l<<endl;
}

void set2(){
    for(int i=l-1;i<r;i++){
        if(ss[i]=='6'){
            for(int j=i;j<r;j++){
                if(ss[j]=='7') res++;
            }
        }
    }
    cout<<res<<endl;
    res=0;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q>>ss;
    for(int i=0;i<n;i++){
        if(ss[i]=='?') br++;
    }
    for(int i=1;i<=q;i++){
        cin>>l>>r;
        if(br==0) set2();
    }
    return 0;
}